1   package csNd;
2   
3   import java.io.File;
4   import java.io.FileInputStream;
5   import java.io.IOException;
6   import java.io.InputStream;
7   import org.apache.commons.net.ftp.FTP;
8   import org.apache.commons.net.ftp.FTPSClient;
9   import org.apache.commons.net.ftp.FTPClient;
10  import org.ini4j.Ini;
11  
12  
13  public class Dumper {
14  	
15  	// campi 
16  	
17  	public String hostFTP;
18  	public String usr;
19  	public String psw;
20  	public int Port;
21  	public FTPClient ftpClient;
22  	public FTPSClient ftps;
23  	public String protocol = "SSL";
24  		
25  	//costruttori
26  	 
27  	public Dumper(String host,String user, String password,int PORT) {
28  		this.hostFTP=host;
29  		this.usr=user;
30  		this.psw=password;
31  		this.Port=PORT;
32  	}
33  	
34  	//metodi
35  	
36  	public synchronized static boolean CheckFTP(String server,String usr,String inskey,int port) {
37  		//FTPClient ftpClient = new FTPClient();
38  		FTPSClient ftps = new FTPSClient();
39  		boolean res=false;
40  		try {
41  			ftps.connect(server);
42              res= ftps.login(usr, inskey);   
43              }catch(Exception e){
44  			return false;
45  		}
46  		try {
47              if (ftps.isConnected()) {
48                  ftps.logout();
49                  ftps.disconnect();
50              }
51          } catch (IOException ex) {
52              ex.printStackTrace();
53              System.out.println("\n**** ERRORE DISCONNESSIONE FTPS ****\n");
54          }
55  		return res;
56  		
57  	}
58  	
59  	
60  	/**@author Alessio Moraschini
61       * 
62       *  Questo metodo serve per salvare un file "filename" nella
63       *  cartella folderpathname presente nel server ftp, usando i dati specificati
64       *  alla creazione dell'oggetto Dumper(host,usr,pssw,port)
65       *  Il file viene salvato con il nome specificato in "ftpname"
66       * 
67       * @return 0 se tutto  andato bene
68       * @return 1 se c' stato un errore
69       */  
70  	public synchronized int SaveRemoteFile(String filename, String ftpname, String folderftpPath, Ini IniFile) {
71  		String FTPdir=IniFile.get("FTP_LOGIN", "PathFTP");
72  		//ftpClient = new FTPClient();
73  		ftps=new FTPSClient(protocol);
74          try {
75              ftps.connect(this.hostFTP, this.Port);
76              ftps.login(this.usr, this.psw);
77              ftps.enterLocalPassiveMode();
78              ftps.setFileType(FTP.BINARY_FILE_TYPE);
79              //testa esistenza cartella specificata in CONFIG.ini)
80              ftps.changeWorkingDirectory(FTPdir);
81              int returnCodeA = ftps.getReplyCode();
82              if (returnCodeA == 550) {//se la directory specificata in ini non esiste
83              	System.out.println("Check della directory:  "+ FTPdir +"\n");
84                  ftps.makeDirectory(FTPdir);
85              }
86              ftps.changeWorkingDirectory(FTPdir);
87              
88              //carico il file usando inputstream         
89              File LocalFile = new File(filename); 
90              String RemoteFile = ftpname;
91              InputStream inputStream = new FileInputStream(LocalFile);    
92              System.out.println("\n### Inizio caricamento file "+FTPdir+"/"+RemoteFile+" ###");
93              boolean done = ftps.storeFile(RemoteFile, inputStream);
94              inputStream.close();
95              if (done) {
96                  System.out.printf(" -> File caricato correttamente!\n");
97              }  
98          } catch (IOException ex) {
99              System.out.println("Error: " + ex.getMessage());
100             ex.printStackTrace();
101             return 1;
102         } finally {
103             try {
104                 if (ftps.isConnected()) {
105                     ftps.logout();
106                     ftps.disconnect();
107                 }
108             } catch (IOException ex) {
109                 ex.printStackTrace();
110                 System.out.println("\n**** ERRORE DISCONNESSIONE FTPS ****\n");
111                 return 1;
112             }
113         }
114 		return 0;		
115 	}	
116 }
117 